define(function(require) {
	var justep = require("$UI/system/lib/justep");
	require("jquery");
	require("css!$UI/system/components/bootstrap/lib/css/bootstrap").load();
	require("$UI/system/components/bootstrap/lib/js/bootstrap");
	require("css!../Font-Awesome/css/font-awesome.min").load();
	require("css!../css/summernote").load();
	require("./summernote");
	require("./lang/summernote-zh-CN");
	(function($) {
		justep.Bind.bindingHandlers.summernote = {
			init : function(element, valueAccessor, allBindings, viewModel, bindingContext) {
				$(element).summernote(
						{
							height : 300,
							lang : 'zh-CN',
							callbacks : {
								onBlur : function() {
									var value = valueAccessor();
									if (justep.Bind.isWriteableObservable(value)) {
										value.set($(element).summernote('code'));
									}
								},
								onImageUpload : function(files) {
									var file = files[0];
									$.ajax({
										data : file,
										type : "POST",
										url : "/baas/common/fileapi/imageupload?filetype=" + file.type + "&catalog=image&length=" + file.size,
										cache : false,
										contentType : false,
										processData : false,
										dataType : "json",
										success : function(ret) {
											if (ret.success) {												
												var imgNode = document.createElement('img');
												imgNode.style.maxWidth="800px";
												imgNode.style.width="100%";
												imgNode.style.display="block";
												imgNode.style.margin="auto";
												imgNode.src = "/baas/common/fileapi/fileget?fileid=" + ret.fileid + "&filename="
														+ encodeURIComponent(file.name);
												$(element).summernote('insertNode', imgNode);
											}
										}
									});
								}
							}
						});
			},
			update : function(element, valueAccessor, allBindings) {
				var value = valueAccessor();
				var valueUnwrapped = justep.Bind.unwrap(value);
				valueUnwrapped === undefined && (valueUnwrapped = null);
				$(element).summernote('code', valueUnwrapped);
			}
		};
	})(jQuery);
});